/* CSVRowWriter.h

Header file for the CSVRowWriter Class used in
XMLToCSVBasic

From Chapter 2 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with XMLToCSVBasic; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef CSVWROWRITER_H
#define CSVWROWRITER_H


#include "BlasterIncludes.h"

// Set up constants
#define OUTPUTBUFFERSIZE 16384
#define MAXCOLUMNS 99
#define MAXCOLUMNSIZE 1024

class CSVRowWriter
{
public:
  CSVRowWriter(ofstream * OutputCSV);	      //  Constructor
  ~CSVRowWriter();				                  //  Destructor
  void write(IXMLDOMElementPtr pRow);

private:
  void formatRow(char * cColumnArray[], int iHighestColumn,
    char * cOutputBuffer);

  ofstream * OutputCSV;                 //  Our output stream
};


#endif
