/* displayParseError.cpp

This is general function gets and displayes to the standard
error output stream information about MSXML DOM2 parsing 
and validation exceptions.

From Chapter 2 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

// Common header files
#include "BlasterIncludes.h"


void displayParseError(IXMLDOMParseErrorPtr spParseError)
{
  //  Display information associated with a ParseError
  //  These can come from parsing or validation

  _bstr_t bstrReason(spParseError->reason);
  _bstr_t bstrSrcText(spParseError->srcText);
  _bstr_t bstrURL(spParseError->url);

  cerr << endl;

  if (bstrReason.length() != 0)
  {
    cerr << "Reason : " << endl << bstrReason << endl;
  }
  if (bstrSrcText.length() != 0)
  {
    cerr << "Source Text : " << endl << bstrSrcText << endl;
  }
  if (bstrURL.length() != 0)
  {
    cerr << "File URL : " << endl << bstrURL << endl;
  }

  cerr << "Position in file = " << spParseError->filepos << 
    endl;
  cerr << "Line             = " << spParseError->line << endl;
  cerr << "Position in line = " << spParseError->linepos << endl
    << endl;

}    
