/* CSVRecordReader.h

Handles reading and parsing rows in CSV files and creating XML

From Chapter 7 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef CSV_RECORD_READER_H
#define CSV_RECORD_READER_H

class CSVRecordReader : public RecordReader
{
public:
  CSVRecordReader(const IXMLDOMDocument2Ptr spFileDescription);
  ~CSVRecordReader();
  int parseRecord(const IXMLDOMElementPtr spRowGrammar);

protected:
  int saveCharacter(const char cInputCharacter);

  //  XML Types
  IXMLDOMNodeListPtr spColumnGrammars;

  //  IO Streams
  //  Basic Types

  //  Basic types
  char cColumnDelimiter;
  char cTextDelimiter;

  int ParsingState;
  int iGrammarIndex;
  int iColumnNumber;

};

#endif
