/* X12RecordWriter.h

Header file for X12RecordWriter class

From Chapter 9 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef X12_RECORD_WRITER_H
#define X12_RECORD_WRITER_H


class X12RecordWriter : public EDIRecordWriter
{
public:
  X12RecordWriter(const IXMLDOMDocument2Ptr spFileDescription,
    ofstream * const OutputFile);
  ~X12RecordWriter();
  int writeISA();
  int writeIEA();
  int writeGS();
  int writeGE();
  int writeST();
  int writeSE();

protected:
  //  Class variables

  //  XML and DOM
  IXMLDOMElementPtr spTPElement;

  //  Basic types
  char cInterchangeControlNumber[16];
  char cGroupControlNumber[16];
  char cTransactionSetCount[16];
  int iFunctionalGroupCount;
  int iTransactionSetCount;
  char cDate8[9];
  char cDate6[7];
  char cTime[5];
};

#endif
