/* RecordHandler.h

Header file for base RecordHandler class

From Chapter 6 of
Using XML with Legacy Business Applications
Copyright (c) 2002 Addison-Wesley Professional

Author: Michael C. Rawlins
Rawlins EC Consulting
PMB 29
14 Canyon Creek Village
Richardson, TX 75080-1602
mike@rawlinsecconsulting.com
972-783-9573

This file is one of several utilities developed for the book.

All utilities developed for the book are free software; you can
redistribute and/or modify them under the terms of the GNU
General Public License, Version 2, as published by the Free
Software Foundation.

These utilities are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the book; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA

The license is also available on the World Wide Web at
http://www.gnu.org/licenses/gpl.html

*/

#ifndef RECORD_HANDLER_H
#define RECORD_HANDLER_H

class RecordHandler
{
public:
  RecordHandler(const IXMLDOMDocument2Ptr spFileDescription);
  ~RecordHandler();
  int createDataCell(int iFieldNumber,
    const IXMLDOMElementPtr spGrammarIn, 
    DataCell * &NewCell);
  int getElementText(const IXMLDOMElementPtr spElementIn,
    char * const cElementText, int iBufferLength);
  int getFieldValue(int iFieldNumber, char * const cFieldContents);
  char setDelimiter(const char * const cDelimiter);
  void setTerminator(const char * const cTerminator);

protected:
  //  XML
  IXMLDOMDocument2Ptr spFileDescription;

  //  Project Classes
  DataCell * CellArray[CELL_ARRAY_SIZE];
  
  //  Basic types
  char RecordBuffer[MAX_RECORD_SIZE];
  char cRecordTerminator1;
  char cRecordTerminator2;
  int iHighestCell;
  int iRecordBufferLength;
};


#endif
